(function(){
	//============================ PARAMETERS =========================================
	
	
	
	
	
	
	//=================================================================================
	//,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,,
	//---------------------------------------------------------------------------------
	//=========== YOU DO NOT NEED TO EDIT ANYTHING BELOW THIS POINT ===================
	//---------------------------------------------------------------------------------
	//'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
	//=================================================================================
	class BetterSlider extends ISliderBarInstance {

		constructor() {
			super()
			this.runtime.addEventListener("tick", ()=>{this.Tick()})
			let runtime = this.runtime;
			//The name of the object (Sprite, TiledBG, 9Patch) that's used for the background
			this.BETTER_SLIDER_BACKGROUND = this.instVars.bgObjectName;
			//The name of the object (Sprite, TiledBG, 9Patch) that's used for the foreground
			this.BETTER_SLIDER_FOREGROUND = this.instVars.fgObjectName;
			//The name of the Text input object that's used for editing the value upon a double click
			this.BETTER_SLIDER_TEXTBOX = this.instVars.textboxObjectName;
			//The name of the Text object that's used for displaying the name of the slider
			this.BETTER_SLIDER_TOOLTIP = this.instVars.tooltipObjectName;
			//The name of the Text object that's used for displaying the value of the slider
			this.BETTER_SLIDER_TEXT_VALUE = this.instVars.valueObjectName;

			this.backgroundObj = runtime.objects[this.BETTER_SLIDER_BACKGROUND].createInstance(this.layer.index, this.x, this.y);
			this.foregroundObj = runtime.objects[this.BETTER_SLIDER_FOREGROUND].createInstance(this.layer.index, this.x, this.y);
			this.textboxObj = runtime.objects[this.BETTER_SLIDER_TEXTBOX].createInstance(this.layer.index, this.x, this.y);
			this.tooltipObj = runtime.objects[this.BETTER_SLIDER_TOOLTIP].createInstance(this.layer.index, this.x, this.y);
			this.textValueObj = runtime.objects[this.BETTER_SLIDER_TEXT_VALUE].createInstance(this.layer.index, this.x, this.y);
			
			this.isVisible = false;
			this.mouseIsDragging = false;
			this.willNeedToStopEditing = false;
			this.willNeedToStopEditingKeyboard = false;
			this.textboxObj.addEventListener("change", () => {
				if (this.instVars.editingValue) {
					this.value = parseFloat(this.textboxObj.text)
					if (this.instVars.forceClamp) {
						this.value = clamp(this.minimum, this.maximum, this.value)
					}
				} 
			})
			
			this.runtime.addEventListener("wheel", (event) => {
				if (this.CursorIsOverSlider()) {
					let step = this.step * (event.deltaY > 0 ? -1 : 1);
					this.value += step
				}
			})
			
			this.runtime.addEventListener("keydown", (event) => {
				if (event.which === 13 && !event.shiftKey) this.willNeedToStopEditingKeyboard = true;
			})
			
			this.runtime.addEventListener("keyup", (event) => {
				if (event.which === 13 && !event.shiftKey && this.willNeedToStopEditingKeyboard)
					this.instVars.editingValue = false;
			})
			
			let lastPointerTime = 0;
			let timeDifference = 300;
			this.runtime.addEventListener("pointerdown", (event) => {
				if (event.button !== 0) return;
				if (this.CursorIsOverSlider()) {
					this.mouseIsDragging = true;
					if (event.timeStamp - lastPointerTime <= timeDifference) this.instVars.editingValue = 1
				}
				else {
					this.willNeedToStopEditing = true
					this.mouseIsDragging = false
				}
				lastPointerTime  = event.timeStamp;
			})
			
			let pointerup = (event) => {
				if (event.button !== 0) return;
				if (!this.CursorIsOverSlider() && this.willNeedToStopEditing) this.instVars.editingValue = 0;
				this.willNeedToStopEditing = false
				this.mouseIsDragging = false
			}
			
			this.runtime.addEventListener("pointerup", pointerup)
			this.runtime.addEventListener("pointercancel", pointerup)
			this.addEventListener("destroy", () => {
				if (this.backgroundObj) this.backgroundObj.destroy();
				if (this.foregroundObj) this.foregroundObj.destroy();
				if (this.textboxObj) this.textboxObj.destroy();
				if (this.tooltipObj) this.tooltipObj.destroy();
				if (this.textValueObj) this.textValueObj.destroy();
			})
		}
		
		CursorIsOverSlider() {
			return this.backgroundObj.containsPoint(this.runtime.mouse.getMouseX(this.layer.index), this.runtime.mouse.getMouseY(this.layer.index));
		}

		Tick() {
			this.isVisible = false;
			
			if (this.BETTER_SLIDER_BACKGROUND !== this.instVars.bgObjectName) {
				if (!this.runtime.objects[this.instVars.bgObjectName]) {
					this.instVars.bgObjectName = this.BETTER_SLIDER_BACKGROUND
					return
				}
				this.BETTER_SLIDER_BACKGROUND = this.instVars.bgObjectName
				this.backgroundObj.destroy();
				this.backgroundObj = this.runtime.objects[this.BETTER_SLIDER_BACKGROUND].createInstance(this.layer.index, this.x, this.y);
			}
			
			if (this.BETTER_SLIDER_FOREGROUND !== this.instVars.fgObjectName) {
				if (!this.runtime.objects[this.instVars.fgObjectName]) {
					this.instVars.fgObjectName = this.BETTER_SLIDER_FOREGROUND
					return
				}
				this.BETTER_SLIDER_FOREGROUND = this.instVars.fgObjectName
				this.foregroundObj.destroy();
				this.foregroundObj = this.runtime.objects[this.BETTER_SLIDER_FOREGROUND].createInstance(this.layer.index, this.x, this.y);
			}
			
			if (this.BETTER_SLIDER_TEXTBOX !== this.instVars.textboxObjectName) {
				if (!this.runtime.objects[this.instVars.textboxObjectName]) {
					this.instVars.textboxObjectName = this.BETTER_SLIDER_TEXTBOX
					return
				}
				this.BETTER_SLIDER_TEXTBOX = this.instVars.textboxObjectName
				this.textboxObj.destroy();
				this.textboxObj = this.runtime.objects[this.BETTER_SLIDER_TEXTBOX].createInstance(this.layer.index, this.x, this.y);
			}
			
			if (this.BETTER_SLIDER_TOOLTIP !== this.instVars.tooltipObjectName) {
				if (!this.runtime.objects[this.instVars.tooltipObjectName]) {
					this.instVars.tooltipObjectName = this.BETTER_SLIDER_TOOLTIP
					return
				}
				this.BETTER_SLIDER_TOOLTIP = this.instVars.tooltipObjectName
				this.tooltipObj.destroy();
				this.tooltipObj = this.runtime.objects[this.BETTER_SLIDER_TOOLTIP].createInstance(this.layer.index, this.x, this.y);
			}
			
			if (this.BETTER_SLIDER_TEXT_VALUE !== this.instVars.valueObjectName) {
				if (!this.runtime.objects[this.instVars.valueObjectName]) {
					this.instVars.valueObjectName = this.BETTER_SLIDER_TEXT_VALUE
					return
				}
				this.BETTER_SLIDER_TEXT_VALUE = this.instVars.valueObjectName
				this.textValueObj.destroy();
				this.textValueObj = this.runtime.objects[this.BETTER_SLIDER_TEXT_VALUE].createInstance(this.layer.index, this.x, this.y);
			}
			
			if (this.mouseIsDragging && !this.instVars.editingValue) {
				this.value = lerp(this.minimum, this.maximum,
					unlerp(this.x, this.x + this.width, this.runtime.mouse.getMouseX(this.layer.index), this.instVars.forceClamp),
					this.instVars.forceClamp);
				this.value = Math.round(this.value / this.step)*this.step;
			}
			
			this.backgroundObj.x = this.x;
			this.backgroundObj.y = this.y;
			this.backgroundObj.angleDegrees = this.angleDegrees;
			this.backgroundObj.isVisible = this.instVars.visible;
			this.backgroundObj.width = this.width;
			this.backgroundObj.height = this.height;
			this.backgroundObj.moveAdjacentToInstance(this, true);
			this.backgroundObj.colorRgb = colorToRGB(this.instVars.bgColor);
			
			this.foregroundObj.x = this.x;
			this.foregroundObj.y = this.y;
			this.foregroundObj.angleDegrees = this.angleDegrees;
			this.foregroundObj.isVisible = this.instVars.visible;
			this.foregroundObj.width = this.width * unlerp(this.minimum, this.maximum, this.value);
			this.foregroundObj.height = this.height;
			this.foregroundObj.moveAdjacentToInstance(this.backgroundObj, true);
			this.foregroundObj.colorRgb = colorToRGB(this.instVars.fgColor);
			
			this.tooltipObj.x = this.x;
			this.tooltipObj.y = this.y;
			this.tooltipObj.angleDegrees = this.angleDegrees;
			this.tooltipObj.isVisible = this.instVars.visible;
			this.tooltipObj.width = this.width;
			this.tooltipObj.height = this.height;
			this.tooltipObj.text = "  " + this.tooltip + "  ";
			this.tooltipObj.moveAdjacentToInstance(this.foregroundObj, true);
			this.tooltipObj.sizePt = this.instVars.tooltipTextSize;
			this.tooltipObj.colorRgb = colorToRGB(this.instVars.tooltipColor);
			
			this.textValueObj.x = this.x;
			this.textValueObj.y = this.y;
			this.textValueObj.angleDegrees = this.angleDegrees;
			this.textValueObj.isVisible = this.instVars.visible;
			this.textValueObj.width = this.width;
			this.textValueObj.height = this.height;
			this.textValueObj.text = "  " + this.value.toString() + "  ";
			this.textValueObj.moveAdjacentToInstance(this.tooltipObj, true);
			this.textValueObj.sizePt = this.instVars.valueTextSize;
			this.textValueObj.colorRgb = colorToRGB(this.instVars.valueColor);
			
			this.textboxObj.x = this.x;
			this.textboxObj.y = this.y;
			this.textboxObj.angleDegrees = this.angleDegrees;
			this.textboxObj.isVisible = this.instVars.visible && this.instVars.editingValue;
			this.textboxObj.width = this.width;
			this.textboxObj.height = this.height;
			this.textboxObj.moveAdjacentToInstance(this.textValueObj, true);
			if (!this.instVars.editingValue) this.textboxObj.text = this.value.toString()
		}

	}
	
	function clamp(min, max, val) {
		return Math.min(Math.max(val, min), max);
	}
	
	function lerp(a, b, x, clamped = false) {
		let ret = a * (1 - x) + b * x;
		return clamped? clamp(a, b, ret) : ret;
	}
	
	function unlerp(a, b, x, clamped = true) {
		let ret = (x - a) / (b - a);
		return clamped? clamp(0, 1, ret) : ret;
	}

	function hslToRgb(hue, saturation, lightness) {
        // based on algorithm from http://en.wikipedia.org/wiki/HSL_and_HSV#Converting_to_RGB
        if (hue == undefined)
        {
            return [1, 1, 1];
        }

        var chroma = (1 - Math.abs((2 * lightness) - 1)) * saturation;
        var huePrime = hue / 60;
        var secondComponent = chroma * (1 - Math.abs((huePrime % 2) - 1));

        huePrime = Math.floor(huePrime);
        var red;
        var green;
        var blue;

        if (huePrime === 0)
        {
            red = chroma;
            green = secondComponent;
            blue = 0;
        }
        else if (huePrime === 1)
        {
            red = secondComponent;
            green = chroma;
            blue = 0;
        }
        else if (huePrime === 2)
        {
            red = 0;
            green = chroma;
            blue = secondComponent;
        }
        else if (huePrime === 3)
        {
            red = 0;
            green = secondComponent;
            blue = chroma;
        }
        else if (huePrime === 4)
        {
            red = secondComponent;
            green = 0;
            blue = chroma;
        }
        else if (huePrime === 5)
        {
            red = chroma;
            green = 0;
            blue = secondComponent;
        }

        var lightnessAdjustment = lightness - (chroma / 2);
        red += lightnessAdjustment;
        green += lightnessAdjustment;
        blue += lightnessAdjustment;

        return [red, green, blue];

    };
	
	function hexToRgb(hex) {
	  var result = /^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);
	  return result? [ parseInt(result[1], 16) / 255, parseInt(result[2], 16) / 255, parseInt(result[3], 16) / 255] : [1,1,1];
	}

	function colorToRGB(color) {
		if (color.startsWith("#"))
		{
			return hexToRgb(color);
		}
		if (color.startsWith("hsl"))
		{
			let[h, s, l] = color.split('(')[1].split(')')[0].split(',').map(x => {
				return x.trim()
			})
			return hslToRgb(h, s / 100, l / 100);
		}
		if (color.startsWith("rgb"))
		{
			let[r, g, b] = color.split('(')[1].split(')')[0].split(',').map(x => {
				x = parseInt(x.trim()).toString(16);
				return (x.length == 1) ? "0" + x : x;
			})
			return [r / 255, g / 255, b / 255];
		}
		return [1,1,1];
	}

	runOnStartup(async runtime =>
	{
		// Code to run on the loading screen.
		// Note layouts, objects etc. are not yet available.
		runtime.objects.BetterSliderBar.setInstanceClass(BetterSlider);
	});
})();

